#include "stdafx.h"
#include "MFCPlayer.h"
#include "MFCPlayerDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define  WM_GRAPHNOTIFY  (WM_USER  + 13)
const	int		TIME_EVENT_PLAYING		=	110119;


CMFCPlayerDlg::CMFCPlayerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCPlayerDlg::IDD, pParent)
	, m_pGraphBuilder(NULL)
	, m_pMediaControl(NULL)
	, m_pMediaSeeking(NULL)
	, m_pMediaEventEx(NULL)
	, m_totalDuration(0)
	, m_timeElapsed(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCPlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROGRESS, m_ProgressCtrl);
}

BEGIN_MESSAGE_MAP(CMFCPlayerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_OPENFILE, &CMFCPlayerDlg::OnBnClickedOpenfile)
	ON_BN_CLICKED(IDC_PAUSE, &CMFCPlayerDlg::OnBnClickedPause)
	ON_BN_CLICKED(IDC_STOP, &CMFCPlayerDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDC_EXIT, &CMFCPlayerDlg::OnBnClickedExit)
	
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START, &CMFCPlayerDlg::OnBnClickedStart)
END_MESSAGE_MAP()

BOOL CMFCPlayerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CMFCPlayerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialog::OnSysCommand(nID, lParam);
}

void CMFCPlayerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CMFCPlayerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

HRESULT CMFCPlayerDlg::InitGraphBuilder()
{
	HRESULT hr;
	CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder,
		(void**)&m_pGraphBuilder);

	if (!m_pGraphBuilder)
	{
		::MessageBox(NULL, _T("Graphic Builderʧ"), _T("Error"), MB_OK);
		return -1L;
	}

	hr = m_pGraphBuilder->QueryInterface(IID_IMediaControl, (void**)&m_pMediaControl);
	hr = m_pGraphBuilder->QueryInterface(IID_IMediaSeeking, (void**)&m_pMediaSeeking);
	hr = m_pGraphBuilder->QueryInterface(IID_IMediaEventEx, (void**)&m_pMediaEventEx);

	if (!m_pMediaControl || !m_pMediaSeeking || !m_pMediaEventEx)
	{
		::MessageBox(NULL, _T("QueryInterface error"), _T("Error"), MB_OK);
		return -1L;
	}

	CWnd*  pWnd = GetDlgItem(IDC_DISPLAY);
	if (pWnd && pWnd->GetSafeHwnd())
		m_pMediaEventEx->SetNotifyWindow((OAHWND)(pWnd->GetSafeHwnd()), WM_GRAPHNOTIFY, 0);
	return S_OK;
}

void CMFCPlayerDlg::OnBnClickedOpenfile()
{
	CFileDialog  dlg(TRUE);
	if (IDOK == dlg.DoModal())
	{
		SetWndText(IDC_FILEPATH, dlg.GetFileName());

		if (!m_pGraphBuilder)
		{
			if (InitGraphBuilder() != S_OK)  return;
		}

		char  totalTime[MAX_PATH] = {0};
		LONGLONG  lDuration = 0;  // 100nsΪλ
		CString  strFilePath = dlg.GetPathName();
			  
		m_pGraphBuilder->RenderFile(strFilePath, NULL);
		m_pMediaSeeking->GetDuration(&lDuration);

		m_totalDuration = lDuration / 10000000;
		long temperorary = (long)m_totalDuration;
		m_step = (float)100 / temperorary;
		m_ProgressCtrl.SetRange(0, 100);
		m_pMediaControl->Run();
		SetTimer(TIME_EVENT_PLAYING, 1000, NULL);
	}
}

void CMFCPlayerDlg::SetWndText(UINT ID, const CString&  strText)
{
	CWnd* pWnd = GetDlgItem(ID);
	if (pWnd && pWnd->GetSafeHwnd())  pWnd->SetWindowText(strText);
}

void CMFCPlayerDlg::OnBnClickedPause()
{
	m_pMediaControl->Pause();
}

void CMFCPlayerDlg::OnBnClickedStop()
{
	m_pMediaControl->Stop();
}

void CMFCPlayerDlg::OnBnClickedExit()
{
	EndDialog(IDOK);
}

void CMFCPlayerDlg::EnableControls(bool  isEnable)
{
	EnableWnd(IDC_PAUSE, isEnable);
	EnableWnd(IDC_STOP, isEnable);
}

void CMFCPlayerDlg::EnableWnd(UINT id, bool  isEnable)
{
	CWnd*  pWnd = GetDlgItem(id);
	if (pWnd && pWnd->GetSafeHwnd())
	{
		pWnd->EnableWindow(isEnable);
	}
}

BOOL CMFCPlayerDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_GRAPHNOTIFY)
	{
		long evCode, param1, param2;
		if (m_pMediaEventEx)
		{
			m_pMediaEventEx->GetEvent(&evCode, &param1, &param2, 0);
			switch(evCode)
			{
			case EC_COMPLETE:
				break;
			default:
				break;
			}
			m_pMediaEventEx->FreeEventParams(evCode, param1, param2);
		}
		return TRUE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CMFCPlayerDlg::OnTimer(UINT_PTR nIDEvent)
{
	CDialog::OnTimer(nIDEvent);
	
	switch(nIDEvent)
	{
	case TIME_EVENT_PLAYING:
		{
			m_timeElapsed++;
			int pos = (int)((float)m_step * (float)m_timeElapsed);
			m_ProgressCtrl.SetPos(m_timeElapsed);
			if (pos >= 100) KillTimer(TIME_EVENT_PLAYING);
		}
		break;
	default:
		break;
	}
}

void CMFCPlayerDlg::OnBnClickedStart()
{
}
